
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>搭建一个私有的Docker registry / iVAN</title>

    <meta name="description" content="搭建一个私有的Docker registry 搭建一个私有的Docker registry [TL;DR] 这是系列的第二篇文章,这系列讲述了我的公司如何把基础服务从PaaS迁移到Docker上 第一篇文章: 我谈到了接触Docker之前的经历: 第三篇文章: 我展示如何使创建镜像的过程自动化以及如何用Docker部署一个Rails应用. 为什么需要搭建一个私有的registry呢?嗯,对于新手来说,Docker Hub(一个Docker公共仓库)只允许你拥有一个免费的私有版本库(repo).其他的公司也开始提供类似服务,但是价格可不便宜.">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">搭建一个私有的Docker registry</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h1>搭建一个私有的Docker registry</h1>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2RuLWxpbnV4Y24ucWJveC5tZS9kYXRhL2F0dGFjaG1lbnQvYWxidW0vMjAxNTA1LzAzLzIzNTA1MnJmOGlxNmk2eDF4aXo4cW8uanBn.jpg"></p>
<p>[TL;DR] 这是系列的第二篇文章，这系列讲述了我的公司如何把基础服务从PaaS迁移到Docker上</p>
<ul>
<li><a href="https://linux.cn/article-5339-1.html" rel="external nofollow noreferrer">第一篇文章</a>: 我谈到了接触Docker之前的经历；</li>
<li><a href="https://linux.cn/article-5408-1.html" rel="external nofollow noreferrer">第三篇文章</a>: 我展示如何使创建镜像的过程自动化以及如何用Docker部署一个Rails应用。</li>
</ul>
<hr>
<br />为什么需要搭建一个私有的registry呢？嗯，对于新手来说，Docker Hub（一个Docker公共仓库）只允许你拥有一个免费的私有版本库（repo）。其他的公司也开始提供类似服务，但是价格可不便宜。另外，如果你需要用Docker部署一个用于生产环境的应用，恐怕你不希望将这些镜像放在公开的Docker Hub上吧！</p>
<p>这篇文章提供了一个非常务实的方法来处理搭建私有Docker registry时出现的各种错综复杂的情况。我们将会使用一个运行于DigitalOcean（之后简称为DO）的非常小巧的512MB VPS 实例。并且我会假定你已经了解了Docker的基本概念，因为我必须集中精力在复杂的事情上！</p>
<h3>本地搭建</h3>
<p>首先你需要安装boot2docker以及docker CLI。如果你已经搭建好了基本的Docker环境，你可以直接跳过这一步。</p>
<p>从终端运行以下命令（我假设你使用OS X，使用 HomeBrew 来安装相关软件，你可以根据你的环境使用不同的包管理软件来安装）:</p>
<pre>
</pre>
<ol>
<li><code>brew install boot2docker docker  </code></li>
</ol>
<p>如果一切顺利（想要了解搭建docker环境的完整指南，请参阅 <a href="http://boot2docker.io/" rel="external nofollow noreferrer">http://boot2docker.io/</a>） ，你现在就能够通过如下命令启动一个 Docker 运行于其中的虚拟机：</p>
<pre>
</pre>
<ol>
<li><code>boot2docker up  </code></li>
</ol>
<p>按照屏幕显示的说明，复制粘贴book2docker在终端输出的命令。如果你现在运行<code>docker ps</code>命令，终端将有以下显示。</p>
<pre>
</pre>
<ol>
<li><code>CONTAINER ID        IMAGE               COMMAND             CREATED             STATUS              PORTS               NAMES  </code></li>
</ol>
<p>好了，Docker已经准备就绪，这就够了，我们回过头去搭建registry。</p>
<h3>创建服务器</h3>
<p>登录进你的DO账号，选择一个预安装了Docker的镜像文件，创建一个新的Drople。（本文写成时选择的是 Image &gt; Applications &gt; Docker 1.4.1 on 14.04）</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2RuLWxpbnV4Y24ucWJveC5tZS9kYXRhL2F0dGFjaG1lbnQvYWxidW0vMjAxNTA1LzAzLzIzNTMyNW02cjFrMW1vbTk2bXFuOG0ucG5n.jpg"></p>
<p>你将会以邮件的方式收到一个根用户凭证。登录进去，然后运行<code>docker ps</code>命令来查看系统状态。</p>
<h3>搭建AWS S3</h3>
<p>我们现在将使用Amazo Simple Storage Service（S3）作为我们registry/repository的存储层。我们将需要创建一个桶(bucket)以及用户凭证（user credentials）来允许我们的docker容器访问它。</p>
<p>登录到我们的AWS账号（如果没有，就申请一个<a href="http://aws.amazon.com/" rel="external nofollow noreferrer">http://aws.amazon.com/</a>），在控制台选择S3（Simpole Storage Service）。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2RuLWxpbnV4Y24ucWJveC5tZS9kYXRhL2F0dGFjaG1lbnQvYWxidW0vMjAxNTA1LzAzLzIzNTMzMG56Y3V6dGR2eGl0NHoya2kucG5n.jpg"></p>
<p>点击 Create Bucket，为你的桶输入一个名字（把它记下来，我们一会需要用到它），然后点击Create。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2RuLWxpbnV4Y24ucWJveC5tZS9kYXRhL2F0dGFjaG1lbnQvYWxidW0vMjAxNTA1LzAzLzIzNTMzM2dwaDh1bWluOXljOThuOWsucG5n.jpg"></p>
<p>OK！我们已经搭建好存储部分了。</p>
<h3>设置AWS访问凭证</h3>
<p>我们现在将要创建一个新的用户。退回到AWS控制台然后选择IAM（Identity &amp; Access Management)。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2RuLWxpbnV4Y24ucWJveC5tZS9kYXRhL2F0dGFjaG1lbnQvYWxidW0vMjAxNTA1LzAzLzIzNTMzN3BodDlpaWY2djJoMDN1aXoucG5n.jpg"></p>
<p>在dashboard的左边，点击Users。然后选择 Create New Users。</p>
<p>如图所示：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2RuLWxpbnV4Y24ucWJveC5tZS9kYXRhL2F0dGFjaG1lbnQvYWxidW0vMjAxNTA1LzAzLzIzNTMzOXl5M2d2MjYzZzJ2Z2x2djMucG5n.jpg"></p>
<p>输入一个用户名（例如 docker-registry）然后点击Create。写下（或者下载csv文件）你的Access Key以及Secret Access Key。回到你的用户列表然后选择你刚刚创建的用户。</p>
<p>在Permission section下面，点击Attach User Policy。之后在下一屏，选择Custom Policy。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2RuLWxpbnV4Y24ucWJveC5tZS9kYXRhL2F0dGFjaG1lbnQvYWxidW0vMjAxNTA1LzAzLzIzNTM0MWc3eTcxN2NxMjQ0N3l3ZnIucG5n.jpg"></p>
<p>custom policy的内容如下：</p>
<pre>
</pre>
<ol>
<li><code>{</code></li>
<li><code>  "Version": "2012-10-17",</code></li>
<li><code>  "Statement": [</code></li>
<li><code>    {</code></li>
<li><code>      "Sid": "SomeStatement",</code></li>
<li><code>      "Effect": "Allow",</code></li>
<li><code>      "Action": [</code></li>
<li><code>        "s3:*"</code></li>
<li><code>      ],</code></li>
<li><code>      "Resource": [</code></li>
<li><code>        "arn:aws:s3:::docker-registry-bucket-name/*",       </code></li>
<li><code>        "arn:aws:s3:::docker-registry-bucket-name"</code></li>
<li><code>      ]</code></li>
<li><code>    }</code></li>
<li><code>  ]</code></li>
<li><code>}</code></li>
</ol>
<p>这个配置将允许用户（也就是regitstry）来对桶上的内容进行操作（读/写）（确保使用你之前创建AWS S3时使用的桶名）。总结一下：当你想把你的Docker镜像从你的本机推送到仓库中时，服务器就会将他们上传到S3。</p>
<h3>安装registry</h3>
<p>现在回过头来看我们的DO服务器，SSH登录其上。我们将要<a href="https://github.com/docker/docker-registry/" rel="external nofollow noreferrer">使用</a>一个<a href="https://registry.hub.docker.com/_/registry/" rel="external nofollow noreferrer">官方Docker registry镜像</a>。</p>
<p>输入如下命令，开启registry。</p>
<pre>
</pre>
<ol>
<li><code>docker run \  </code></li>
<li><code>         -e SETTINGS_FLAVOR=s3 \</code></li>
<li><code>         -e AWS_BUCKET=bucket-name \</code></li>
<li><code>         -e STORAGE_PATH=/registry \</code></li>
<li><code>         -e AWS_KEY=your_aws_key \</code></li>
<li><code>         -e AWS_SECRET=your_aws_secret \</code></li>
<li><code>         -e SEARCH_BACKEND=sqlalchemy \</code></li>
<li><code>         -p 5000:5000 \</code></li>
<li><code>         --name registry \</code></li>
<li><code>         -d \</code></li>
<li><code>         registry</code></li>
</ol>
<p>Docker将会从Docker Hub上拉取所需的文件系统分层（fs layers）并启动守护容器（daemonised container）。</p>
<h3>测试registry</h3>
<p>如果上述操作奏效，你可以通过ping命令，或者查找它的内容来测试registry（虽然这个时候容器还是空的）。</p>
<p>我们的registry非常基础，而且没有提供任何“验明正身”的方式。因为添加身份验证可不是一件轻松事（至少我认为没有一种部署方法是简单的，像是为了证明你努力过似的），我觉得“查询/拉取/推送”仓库内容的最简单方法就是通过SSH通道的未加密连接（通过HTTP）。</p>
<p>打开SSH通道的操作非常简单：</p>
<pre>
</pre>
<ol>
<li><code>ssh -N -L 5000:localhost:5000 root@your_registry.com</code></li>
</ol>
<p>这条命令建立了一条从registry服务器（前面执行<code>docker run</code>命令的时候我们见过它）的5000号端口到本机的5000号端口之间的 SSH 管道连接。</p>
<p>如果你现在用浏览器访问 <a href="http://localhost:5000/v1/_ping" rel="external nofollow noreferrer">http://localhost:5000/v1/_ping</a>，将会看到下面这个非常简短的回复。</p>
<pre>
</pre>
<ol>
<li><code>{}</code></li>
</ol>
<p>这个意味着registry工作正常。你还可以通过登录 <a href="http://localhost:5000/v1/search" rel="external nofollow noreferrer">http://localhost:5000/v1/search</a> 来查看registry内容，内容相似：</p>
<pre>
</pre>
<ol>
<li><code>{</code></li>
<li><code>  "num_results": 2,</code></li>
<li><code>  "query": "",</code></li>
<li><code>  "results": [</code></li>
<li><code>    {</code></li>
<li><code>      "description": "",</code></li>
<li><code>      "name": "username/first-repo"</code></li>
<li><code>    },</code></li>
<li><code>    {</code></li>
<li><code>      "description": "",</code></li>
<li><code>      "name": "username/second-repo"</code></li>
<li><code>    }</code></li>
<li><code>  ]</code></li>
<li><code>}</code></li>
</ol>
<h3>创建一个镜像</h3>
<p>我们现在创建一个非常简单的Docker镜像，来检验我们新弄好的registry。在我们的本机上，用如下内容创建一个Dockerfile（这里只有一点代码，在下一篇文章里我将会展示给你如何将一个Rails应用绑定进Docker容器中。）：</p>
<pre>
</pre>
<ol>
<li><code>#  ruby 2.2.0 的基础镜像</code></li>
<li><code>FROM ruby:2.2.0</code></li>
<li><code></code></li>
<li><code>MAINTAINER Michelangelo Chasseur &lt;michelangelo.chasseur@touchwa.re&gt;  </code></li>
</ol>
<p>并创建它：</p>
<pre>
</pre>
<ol>
<li><code>docker build -t localhost:5000/username/repo-name .  </code></li>
</ol>
<p><code>localhost:5000</code>这个部分非常重要：Docker镜像名的最前面一个部分将告知<code>docker push</code>命令我们将要把我们的镜像推送到哪里。在我们这个例子当中，因为我们要通过SSH管道连接远程的私有registry，<code>localhost:5000</code>精确地指向了我们的registry。</p>
<p>如果一切顺利，当命令执行完成返回后，你可以输入<code>docker images</code>命令来列出新近创建的镜像。执行它看看会出现什么现象？</p>
<h3>推送到仓库</h3>
<p>接下来是更好玩的部分。实现我所描述的东西着实花了我一点时间，所以如果你第一次读的话就耐心一点吧，跟着我一起操作。我知道接下来的东西会非常复杂（如果你不自动化这个过程就一定会这样），但是我保证到最后你一定都能明白。在下一篇文章里我将会使用到一大波shell脚本和Rake任务，通过它们实现自动化并且用简单的命令实现部署Rails应用。</p>
<p>你在终端上运行的docker命令实际上都是使用boot2docker虚拟机来运行容器及各种东西。所以当你执行像<code>docker push some_repo</code>这样的命令时，是boot2docker虚拟机在与registry交互，而不是我们自己的机器。</p>
<p>接下来是一个非常重要的点：为了将Docker镜像推送到远端的私有仓库，SSH管道需要在boot2docker虚拟机上配置好，而不是在你的本地机器上配置。</p>
<p>有许多种方法实现它。我给你展示最简短的一种（可能不是最容易理解的，但是能够帮助你实现自动化）</p>
<p>在这之前，我们需要对 SSH 做最后一点工作。</p>
<h3>设置 SSH</h3>
<p>让我们把boot2docker 的 SSH key添加到远端服务器的“已知主机”里面。我们可以使用ssh-copy-id工具完成，通过下面的命令就可以安装上它了：</p>
<pre>
</pre>
<ol>
<li><code>brew install ssh-copy-id  </code></li>
</ol>
<p>然后运行：</p>
<pre>
</pre>
<ol>
<li><code>ssh-copy-id -i /Users/username/.ssh/id_boot2docker root@your-registry.com  </code></li>
</ol>
<p>用你ssh key的真实路径代替<code>/Users/username/.ssh/id_boot2docker</code>。</p>
<p>这样做能够让我们免密码登录SSH。</p>
<p>现在我们来测试以下：</p>
<pre>
</pre>
<ol>
<li><code>boot2docker ssh "ssh -o 'StrictHostKeyChecking no' -i /Users/michelangelo/.ssh/id_boot2docker -N -L 5000:localhost:5000 root@registry.touchwa.re &amp;" &amp;  </code></li>
</ol>
<p>分开阐述：</p>
<ul>
<li><code>boot2docker ssh</code>允许你以参数的形式传递给boot2docker虚拟机一条执行的命令；</li>
<li>最后面那个<code>&amp;</code>表明这条命令将在后台执行；</li>
<li><code>ssh -o 'StrictHostKeyChecking no' -i /Users/michelangelo/.ssh/id_boot2docker -N -L 5000:localhost:5000 root@registry.touchwa.re &amp;</code>是boot2docker虚拟机实际运行的命令；
<ul>
<li><code>-o 'StrictHostKeyChecking no'</code>——不提示安全问题；</li>
<li><code>-i /Users/michelangelo/.ssh/id_boot2docker</code>指出虚拟机使用哪个SSH key来进行身份验证。（注意这里的key应该是你前面添加到远程仓库的那个）</li>
<li>最后我们将打开一条端口5000映射到localhost:5000的SSH通道。</li>
</ul>
</li>
</ul>
<h3>从其他服务器上拉取</h3>
<p>你现在将可以通过下面的简单命令将你的镜像推送到远端仓库：</p>
<pre>
</pre>
<ol>
<li><code>docker push localhost:5000/username/repo_name  </code></li>
</ol>
<p>在下一篇<a href="https://linux.cn/article-5408-1.html" rel="external nofollow noreferrer">文章</a>中，我们将会了解到如何自动化处理这些事务，并且真正地容器化一个Rails应用。请继续收听！</p>
<p>如有错误，请不吝指出。祝你Docker之路顺利！</p>
<p>原文发布时间：2015-05-04</p>
<p>本文来自云栖合作伙伴“linux中国”</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 05:53:17</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e6%9c%8d%e5%8a%a1%e5%99%a8/" title="服务器">服务器</a>, <a href="https://www.iamivan.net/tag/%e9%95%9c%e5%83%8f/" title="镜像">镜像</a>, <a href="https://www.iamivan.net/tag/%e5%ae%b9%e5%99%a8/" title="容器">容器</a>, <a href="https://www.iamivan.net/tag/docker/" title="docker">docker</a>, <a href="https://www.iamivan.net/tag/ssh/" title="SSH">SSH</a>, <a href="https://www.iamivan.net/tag/registry/" title="registry">registry</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>搭建一个私有的Docker registry的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MNjeL4M.html" rel="bookmark">搭建一个私有的Docker registry教程&lowbar;docker</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				为什么需要搭建一个私有的registry呢?嗯,对于新手来说,Docker Hub(一个Docker公共仓库)只允许你拥有一个免费的私有版本库(repo).其他的公司也开始提供类似服务,但是价格可不便宜.另外,如果你需要用Docker部署一个用于生产环境的应用,恐怕你不希望将这些镜像放在公开的Docker Hub上吧! 这篇文章提供了一个非常务实的方法来处理搭建私有Docker registry时出现的各种错综复杂的情况.我们将会使用一个运行于DigitalOcean(之后简称为DO)的非常小巧			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3rPAJz.html" rel="bookmark">基于OSS搭建私有 Docker Registry</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				基于OSS搭建私有 Docker Registry Docker Registry 作为 Docker 的核心组件之一负责了镜像的存储以及分发.用户只需要使用 Docker 的客户端就可以直接和 Registry 进行交互,下载和上传镜像.最初版本的 Registry 由 Python 实现.由于设计初期在安全性,性能以及 API 的设计上有着诸多的缺陷,该版本在 0.9 之后停止了开发.新的项目由 Go 语言开发,所有的API,底层存储方式,系统架构都进行了全面的重新设计已解决上一代 Regi			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQr5AGM.html" rel="bookmark">deploy owned private docker registry based on docker HUB registry image</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				docker HUB提供了registry的image, 可以非常方便的搭建私有regisrty. 当然你也可以选择从docker-registry的源码来搭建. 见 : https://github.com/docker/docker-registry 本文主要说一下使用docker registry image搭建私有registry. 1. 首先要部署docker 参考 :  https://docs.docker.com/installation/#installation 2. 启动d			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mq8BEGb.html" rel="bookmark">Docker  Registry 私有仓库搭建详细步骤&lowbar;docker</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Docker  Registry 私有仓库搭建 官方已经提供了很多版本的 Linux 镜像,直接从官方仓库(Public Repositories)下载就可以了.如果考虑到安全性和速度,我们可能会想在自己局域网里架设一个私有仓库(Private Repositories)来放我们自己的镜像,Docker-Registry 正是我们需要的工具. 本次搭建 docker-registry server (dev) (v0.9.0) 添加docker用户和目录 为了安全起见,我们可以添加一个用户doc			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZgXvab.html" rel="bookmark">docker registry安装简单命令实现&lowbar;docker</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文计划使用3条命令来运行一个Docker registry私服,其实很简单 环境准备: docker 1.11.2 compose文件docker-compose.yml version: '2' services: registry: image: registry:2.5.1 hostname: registry ports: - &quot;5000:5000&quot; environment: - TZ=&quot;Asia/Shanghai&quot; - &quot;REGISTRY_AU			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/My2jevp.html" rel="bookmark">docker4 dotnet使用Azure云存储构建高速 Docker registry</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				使用Docker来构建应用程序最常见的操作就是 docker run 或者 docker pull了,但是由于众所周知的原因,在国内想要高速稳定的获取docker hub上面的资源并不是件容易的事情,虽然国内的一些docker社区也提供了所谓的加速器,但是实测结果并不理想.今天这篇文章就给大家介绍一下怎么借助Azure Storage来搭建一个高速的私有 Docker Hub (Registiry). 云存储构建高速 Docker registry&quot; src=&quot;http://p9.ps			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zDYljWb.html" rel="bookmark">建立docker私有库&lpar;docker registry&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.使用fedora 20(IP为192.168.1.103)作为测试服务器(centos 7,redhat 7通用)   2.安装docker Java代码   yum -y install docker-io docker-registry    特别说明,fedora更新的docker 1.3.1提交到本地库有问题,有1.3.0的docker没问题.若以后再更新版本,按照上面的操作 Java代码   yum -y install http://mirrors.163.com/fedora/			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MWleVjp.html" rel="bookmark">Docker入门教程（四）Docker Registry</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文讲的是Docker入门教程(四)Docker Registry,[编者的话]DockerOne组织翻译了Flux7的Docker入门教程,本文是系列入门教程的第四篇,介绍了Docker Registry,它是Docker中的重要组件.本文通过情景演绎的方式对其进行了介绍,图文并茂,强烈推荐读者阅读. 在Docker系列教程的上一篇文章中,我们讨论了Dockerfile的重要性并提供了一系列Dockerfile的命令,使镜像的自动构建更加容易.在这篇文章中,我们将介绍Docker的一个重要组件			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pk00arz.html" rel="bookmark">Centos 7&period;x 使用Docker registry镜像创建私有仓库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				有时候使用 Docker Hub 这样的公共仓库可能不方便,并且公司的私有镜像为了业务安全,也不会push到docker hub上,用户可以创建一个本地仓库供私人使用.类似于git 和maven一样,同时节省服务器下载和上传镜像带宽. 那什么是docker registry呢 Docker Registry由三个部分组成:index,registry,registry client. 可以把Index认为是负责登录.负责认证.负责存储镜像信息和负责对外显示的外部实现,而registry则是负责存			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xp8jLxb.html" rel="bookmark" class="title">socket-android模拟器运行正常，真机测试程序崩溃</a>
					<div>
						问题描述 android模拟器运行正常,真机测试程序崩溃 一个按钮,点击调用shut_code发送信息.shut_code贴上: private void shut_code() { String m ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM6A4Ob.html" rel="bookmark" class="title">用XML实现弹出式菜单</a>
					<div>
						xml|菜单   XML已经成为了新一代网络计算的世界语,这一点已经在各大软件公司的产品中逐步体现出来.XML本身并不是一种计算语言,而更多表现为一种数据描述的格式.相对于HTML,它更多具有数据定义 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2MWo9GM.html" rel="bookmark" class="title">运筹帷幄 用CSS控制网站总&OpenCurlyDoubleQuote;队形&rdquo;</a>
					<div>
						css|控制 网页设计中我们通常需要统一网页的整体风格,统一的风格大部分涉及到网页中文字属性.网页背景色以及链接文字属性等等,如果我们应用CSS来控制这些属性,会大大提高网页设计速度,更加统一网页总体 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpn5AKM.html" rel="bookmark" class="title">客户端Cookie中文编程</a>
					<div>
						cookie|编程|客户端|中文 在Cookie的使用中,我们发现这样一个问题:如果写入Cookie的内容是中文(如用户称呼),用服务器端程序(如ASP 或PHP)读出完全正确,但是用一般的JavaS ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPQwmz.html" rel="bookmark" class="title">编程基础讲解</a>
					<div>
						编程 本来想自己写一个关于数组得教程的,结果今天发现一个不错的关于数组得教程,就省力气了,嘿嘿.作者: FlashGuru 如果你对数组感性趣的话,那么你也一定了解变量吧.变量是装着数据的容器,数据可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YMROyap.html" rel="bookmark" class="title">Apache重负荷服务器应如何优化</a>
					<div>
						一天两万个请求确实不大,但如果在高峰时期出现,而晚间或其它时间没有,呈正态分布,且均是需要时间的下载服务,那负载还是很大的. Apache允许为请求开的最大进程数是256,MaxClients的限制是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPvkwz.html" rel="bookmark" class="title">用J2SE1&period;5建立多任务的Java应用程序</a>
					<div>
						J2SE 5.0中的java.util.concurrent程序包提供了一个新的线程框架组件,这个框架组件处理了与建立.执行和管理线程相关的很多低层细节信息.在本文中我们将细致地了解一下它的重要特性. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj75rVM.html" rel="bookmark" class="title">Java中设计与使用迭代器</a>
					<div>
						1.迭代器设计 迭代器是一种模式,它可以使得对于序列类型的数据结构的遍 历行为与被遍历的对象分离,即我们无需关心该序列的底层结构是 什么样子的. 一般的迭代器对外提供的接口有: [1]检查是否至序列末 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVnZxkz.html" rel="bookmark" class="title">CentOS使用上一条命令的所有参数详解</a>
					<div>
						  减少键盘输入,可以大大提高程序员的工作效率,快捷键的使用就是一个很好的例子.程序员经常使用终端.那么在终端上有没有类似的&quot;快捷键&quot;可以提高我们的效率呢?程序员的工作往往是前后相 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKPPNp.html" rel="bookmark" class="title">excel表格中怎么制作除夕倒自动倒计时牌&quest;</a>
					<div>
						excel表格中怎么制作除夕倒自动倒计时牌?   1.首先启动excle2010快捷方式,执行文件-选项命令. 2.接着弹出excel选项对话框,在该对话框中选择高级选项,勾选使用1904日期系统,点 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8jOPNb.html" rel="bookmark" class="title">QQ输入法for Mac如何下载及安装</a>
					<div>
						  QQ输入法for Mac下载及安装的方法如下: 点击http://shurufa.qq.com/mac/下载QQ输入法for Mac最新发布的版本.下载后,请双击安装包开始安装,建议全部选择默认设 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNErD4b.html" rel="bookmark" class="title">Win7笔记本摄像头打不开怎么回事</a>
					<div>
						  Win7笔记本摄像头打不开怎么回事 一.电脑设置启用摄像头 1.在计算机上右击,选择&quot;管理&quot;: 2.如下图: 3.单击&quot;设备管理器&quot;,然后选择图像设备下的摄 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8ZEJ4b.html" rel="bookmark" class="title">jquery下div 的resize事件示例代码</a>
					<div>
						 这篇文章主要介绍了某位大神写的jquery下div 的resize事件,需要的朋友可以参考下 这是某位大神写的jquery下div 的resize事件.   代码如下: //resize of di ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQrK7KM.html" rel="bookmark" class="title">CTO下午茶&colon; 全景洞悉，心想事成</a>
					<div>
						本文讲的是 :  CTO下午茶: 全景洞悉,心想事成  ,  知彼知己,胜乃不殆:知天知地,胜乃不穷. --&lt;孙子兵法&gt; 早在 2500 年前,孙子就提出了 &quot;知&quot; 在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVN3OKz.html" rel="bookmark" class="title">筛法求素数</a>
					<div>
						#include &lt;iostream&gt; #include &lt;vector&gt; using namespace std; #define MAX_LEN 1000000 void  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9Yo1KM.html" rel="bookmark" class="title">动态设置执行顺序和功能的问题</a>
					<div>
						问题描述 要插入一条数据,但插入之前需要做一系列的条件判断,现有条件判断1,条件判断2,条件判断3,每次条件判断都要结合DAO,PO来操作,需要通过全部的判断才能最后写入数据,解决方案一:用存储过程封 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba7APwp.html" rel="bookmark" class="title">创业11年，我填过的5个大坑！&lpar;转&rpar;</a>
					<div>
						创业 11 年一小伙,开过酒吧.买过潮品.送过外卖,也正经上过几年班;还开过广告公司.公关公司.销售公司.网络科技公司.相较于同龄人,真算得是个创业达人,今天,一起来看看他亲身经历创业后,如何细数 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bKYPm7p.html" rel="bookmark" class="title">Windows 10可能会限制你的网速，如何改变或提速？</a>
					<div>
						微软已经开始推送Win10一周年更新正式版系统,此前微软通过网络发送TCP数据用来提升性能,该功能最初在Windows Vista出现,一直到现在,也包括Windows10系统.对一些人来说该功能可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWl85mp.html" rel="bookmark" class="title">解析娱乐明星如何在Facebook上招揽人气</a>
					<div>
						对于娱乐圈的明星来说,制造话题和吸引观众是他们永远不懈追求的事,而如今,互联网时代,娱乐圈或许称得上是最会运用Facebook页面来吸引粉丝注意的产业,不过,想成为像女神卡卡般拥有上千万粉丝,可不是每 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bod9YvM.html" rel="bookmark" class="title">iPhone3GS将继续开拓发展中国家市场 暂时不会停产</a>
					<div>
						据国外媒体报道,据美国投行Jefferies分析师彼得米塞克(Peter Misek)预计,苹果在2009年首次发布的iPhone3GS将会继续面向发展中国家市场销售,会在今年晚些时候停产的可能性很小 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLgeyvM.html" rel="bookmark" class="title">一位数据科学家的私房工具清单</a>
					<div>
						作为一位万人敬仰的数据科学家,不但需要培育一棵参天技能树,私人武器库里没有一票玩得转的大火力工具也是没法在江湖中呼风唤雨的. 近日北卡来罗纳大学CTO,一位数据科学家Jefferson Heard分享 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBgNRKM.html" rel="bookmark" class="title">关键词排名优化不理想的原因分析</a>
					<div>
						做SEO最明显的特征就是排名的提升,关键词排名的提升对于新手是至关重要的,SEO的技术并不难只是有的新手没有努力去实践,或者是很多新手都半途而废,SEO的实验周期长且枯燥.所以优化的时候细节也不能放过 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyW0OZz.html" rel="bookmark" class="title">百度ueditor编辑器二次开发实例</a>
					<div>
						最近在做一个后台的项目,项目中用到了复文本框,公司用的是UEditor,但是需求为了更方便编辑图片,特意提了如下功能: 1.上传图片时图片宽度固定为500,长度等比例进行缩放,但不限制单张图片长度:图 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr2JEVM.html" rel="bookmark" class="title">DeepMind发布《星际争霸 II》深度学习环境</a>
					<div>
						上个月,DeepMind和暴雪终于开源了&lt;星际争霸II &gt;的机器学习平台.本文介绍了基于星际争霸II游戏的强化学习环境SC2LE(&lt;星际争霸II &gt;学习环境). 论文描述&lt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL5kQWz.html" rel="bookmark" class="title">关于struts2&plus;spring2&plus;hibernate3的问题</a>
					<div>
						问题描述 信息: Using DataSource [com.mchange.v2.c3p0.ComboPooledDataSource@e64686[ acquireIncrement -&gt;  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boq7qBp.html" rel="bookmark" class="title">中国消费风向标报告2012</a>
					<div>
						在2012年的4月10日,淘宝网与国内最大的市场研究公司ctr双方联合发布了&lt;中国消费风向标报告2012&gt;.而根据报告显示,我国居民消费能力目前持续上扬,在2011年的上半年家庭平均月支出 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
									<a href="https://www.iamivan.net/a/p8GNZBM.html" class="thumbnail">
				<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcmVhZC5odG1sNS5xcS5jb20vaW1hZ2U/c3JjPWZvcnVtJmFtcDtxPTUmYW1wO3I9MCZhbXA7aW1nZmxhZz03JmFtcDtpbWFnZVVybD1odHRwOi8vZXNzYXkuYjAudXBhaXl1bi5jb20vMTc0Ny82Mzg5NjUvMC5qcGc=.jpg">
							</a>
							<div class="info"   >
					<a href="https://www.iamivan.net/a/p8GNZBM.html" rel="bookmark" class="title">可穿戴式设备如何突破市场困局？</a>
					<div>
						成功者总是不约而同的配合着时代的需求-引自电影&lt;中国合伙人&gt;. 前几天写了一篇文章,关于可穿戴式设备和大数据结合在未来改善用户的健康状况,收到了很多朋友的反馈,反响还不错. 也有很多朋友提 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK0B05M.html" rel="bookmark" class="title">做网站不是一天两天就能做好的</a>
					<div>
						做网站不是一天两天就能做好的,就算网站已经有很好的排名了也不能马虎,要保持继续优化继续维护,每天都要去检查网站是否健康,这才是一个站长应该做的事. 作为站长最头疼的莫非就是网站被K了,网站排名一下从百 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDXlX6z.html" rel="bookmark" class="title">怎么一键还原系统 U大师一键还原系统教程</a>
					<div>
						1.运行&quot;电脑版一键备份还原系统.exe&quot;文件,打开之后点击&quot;一键还原系统&quot;操作.(前提是需要先&quot;一键备份系统&quot;,原先有备份才可以还原,之前 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgP8qBp.html" rel="bookmark" class="title">mysql explain type连接类型示例</a>
					<div>
						对于MySQL执行计划的获取,我们可以通过explain方式来查看,explain方式看似简单,实际上包含的内容很多,尤其是输出结果中的type类型列.理解这些不同的类型,对于我们SQL优化举足轻重, ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.030 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
